import {Computesite} from './computesite';
// Identities are defined by a username on a computer, but rather than just
// DNS entry, there is extra info in the Computesite
export class Identity {
  username: string;
  site: Computesite;
  authservice: SshAuthzServer;
  keyCerts: KeyCert[];
  constructor( username: string, site: Computesite) {
    this.username = username;
    this.site = site;
    this.keyCerts = [];
  }

  copy_skip_catalog(): Identity {
    let id = new Identity(null,null);
    id.username = this.username;
    id.site = new Computesite();
    id.site.url = this.site.url;
    id.site.host = this.site.host;
    id.site.name = this.site.name;
    id.site.cafingerprint = this.site.cafingerprint;
    id.site.dtn = this.site.dtn;
    return id;
  }
  displayName(): string {
    return this.username+'@'+this.site.name;
  }
  repr(): string {
    return JSON.stringify([this.username,this.site.cafingerprint,this.site.host,this.site.url]);
  }
}

export class AuthToken {
  token: string;
  sshauthzservice: SshAuthzServer;
  constructor( token: string, sshauthzservice: SshAuthzServer ) {
    this.token = token;
    this.sshauthzservice = sshauthzservice;
  }
}

export class KeyCert {
  key: string;
  cert: string;
  // authservice: SshAuthzServer;
}

export class SshAuthzServer {
  base: string;
  authorise: string;
  sign: string;
  client_id: string;
  name: string;
  icon: string;
  scope: string;
  logout: string;
  userdefined: boolean;
  cafp: string;
  signup: string;
}
